use crate::Color;
use serde::{Deserialize, Serialize};
use sgf::go::Game;
use typeshare::typeshare;

#[derive(Clone, Debug, Serialize, Deserialize)]
#[typeshare]
pub struct GameReviewView {
    pub black_player: String,
    pub white_player: String,
    pub tree: Node,
}

#[derive(Clone, Debug, Serialize, Deserialize)]
#[typeshare]
pub struct Position {
    pub column: u8,
    pub row: u8,
}

#[derive(Clone, Debug, Serialize, Deserialize)]
#[typeshare]
pub struct Node {
    pub color: Color,
    pub position: Position,
    pub children: Vec<Node>,
}

pub fn review(game: &Game) -> GameReviewView {
    GameReviewView {
        black_player: "savanni".to_owned(),
        white_player: "kat".to_owned(),
        tree: Node {
            color: Color::Black,
            position: Position { column: 3, row: 3 },
            children: vec![Node {
                color: Color::White,
                position: Position {
                    column: 15,
                    row: 15,
                },
                children: vec![Node {
                    color: Color::Black,
                    position: Position { column: 15, row: 3 },
                    children: vec![],
                }],
            }],
        },
    }
}
